// CDUCCREPORT.cpp :  Microsoft Visual C++  ActiveX ؼװĶ


#include "stdafx.h"
#include "CDUCCREPORT.h"

// Dispatch interfaces referenced by this interface
#include "xdpage.h"
#include "xdwindow.h"
#include "xdshape.h"
#include "xdgroupshape.h"
#include "xdlinkshape.h"
#include "xdportsshape.h"
#include "xdportshape.h"
#include "xdeformshape.h"

/////////////////////////////////////////////////////////////////////////////
// CDUCCREPORT

IMPLEMENT_DYNCREATE(CDUCCREPORT, CWnd)

/////////////////////////////////////////////////////////////////////////////
// CDUCCREPORT properties

long CDUCCREPORT::GetCanvasWidth()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void CDUCCREPORT::SetCanvasWidth(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

long CDUCCREPORT::GetCanvasHeight()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void CDUCCREPORT::SetCanvasHeight(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

LPDISPATCH CDUCCREPORT::GetParent()
{
	LPDISPATCH result;
	GetProperty(0x7be, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCREPORT::SetParent(LPDISPATCH propVal)
{
	SetProperty(0x7be, VT_DISPATCH, propVal);
}

LPDISPATCH CDUCCREPORT::GetRoot()
{
	LPDISPATCH result;
	GetProperty(0x7bd, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCREPORT::SetRoot(LPDISPATCH propVal)
{
	SetProperty(0x7bd, VT_DISPATCH, propVal);
}

CXDPage CDUCCREPORT::GetActivePage()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bb, VT_DISPATCH, (void*)&pDispatch);
	return CXDPage(pDispatch);
}

void CDUCCREPORT::SetActivePage(LPDISPATCH propVal)
{
	SetProperty(0x7bb, VT_DISPATCH, propVal);
}

CXDWindow CDUCCREPORT::GetActiveWindow()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bc, VT_DISPATCH, (void*)&pDispatch);
	return CXDWindow(pDispatch);
}

void CDUCCREPORT::SetActiveWindow(LPDISPATCH propVal)
{
	SetProperty(0x7bc, VT_DISPATCH, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// CDUCCREPORT operations

long CDUCCREPORT::AddRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCREPORT::AddTextShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszText)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszText);
	return result;
}

long CDUCCREPORT::AddEllipseShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCREPORT::AddRoundRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCREPORT::AddHyLinkShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

long CDUCCREPORT::AddBmpFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCREPORT::AddEmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCREPORT::AddWmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCREPORT::AddShapeByType(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

long CDUCCREPORT::AddCompositeShapeByFile(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCREPORT::AddCompositeShapeByID(short xLeft, short yTop, short xRight, short yBottom, short nResId, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, nResId, lpszCaption);
	return result;
}

long CDUCCREPORT::AddLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCREPORT::AddDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

BOOL CDUCCREPORT::Read(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x10, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

BOOL CDUCCREPORT::Write(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x11, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCREPORT::Export()
{
	InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Undo()
{
	InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Redo()
{
	InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Cut()
{
	InvokeHelper(0x15, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Copy()
{
	InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Paste()
{
	InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::Clear()
{
	InvokeHelper(0x18, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ClearAll()
{
	InvokeHelper(0x19, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::SelectAll()
{
	InvokeHelper(0x1a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::GetShowGrid()
{
	BOOL result;
	InvokeHelper(0x1b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetShowGrid(BOOL bGrid)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGrid);
}

void CDUCCREPORT::OnGridProp()
{
	InvokeHelper(0x1d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::GetDesignMode()
{
	BOOL result;
	InvokeHelper(0x1e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetDesignMode(BOOL bMode)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bMode);
}

BOOL CDUCCREPORT::GetSnapToGrid()
{
	BOOL result;
	InvokeHelper(0x20, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetSnapToGrid(BOOL bSnap)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bSnap);
}

BOOL CDUCCREPORT::GetGlueToHandle()
{
	BOOL result;
	InvokeHelper(0x22, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetGlueToHandle(BOOL bGlue)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGlue);
}

BOOL CDUCCREPORT::GetShowPageBreakLine()
{
	BOOL result;
	InvokeHelper(0x24, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetShowPageBreakLine(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x25, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

BOOL CDUCCREPORT::GetShowPort()
{
	BOOL result;
	InvokeHelper(0x26, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetShowPort(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x27, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

long CDUCCREPORT::GetZoomPercent()
{
	long result;
	InvokeHelper(0x28, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetZoomPercent(long nZoom)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x29, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nZoom);
}

void CDUCCREPORT::ZoomIn()
{
	InvokeHelper(0x2a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomOut()
{
	InvokeHelper(0x2b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomToFitPage()
{
	InvokeHelper(0x2c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomToFitPageHeight()
{
	InvokeHelper(0x2d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomToFitPageWidth()
{
	InvokeHelper(0x2e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomToFitSelect()
{
	InvokeHelper(0x2f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ZoomToRect(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x30, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCREPORT::ZoomToSelection()
{
	InvokeHelper(0x31, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoZoomWithinRect()
{
	InvokeHelper(0x32, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowPagePropDlg()
{
	InvokeHelper(0x33, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowHeaderAndFooterDlg()
{
	InvokeHelper(0x34, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowTextDlg()
{
	InvokeHelper(0x35, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowBulletsDlg()
{
	InvokeHelper(0x36, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowLineDlg()
{
	InvokeHelper(0x37, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowFillDlg()
{
	InvokeHelper(0x38, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowShadowDlg()
{
	InvokeHelper(0x39, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowEventDlg()
{
	InvokeHelper(0x3a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowCustomDlg()
{
	InvokeHelper(0x3b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawSelect()
{
	InvokeHelper(0x3c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawLine()
{
	InvokeHelper(0x3d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawArrowLine()
{
	InvokeHelper(0x3e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawCrossLine()
{
	InvokeHelper(0x3f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawArrowBezierLine()
{
	InvokeHelper(0x40, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawDimLine()
{
	InvokeHelper(0x41, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawFreeLine()
{
	InvokeHelper(0x42, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawFreeCloseLine()
{
	InvokeHelper(0x43, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawPolyLine()
{
	InvokeHelper(0x44, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawPolygon()
{
	InvokeHelper(0x45, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawEllipse()
{
	InvokeHelper(0x46, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRectangle()
{
	InvokeHelper(0x47, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRoundRect()
{
	InvokeHelper(0x48, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawCloseBezier()
{
	InvokeHelper(0x49, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawBezierLine()
{
	InvokeHelper(0x4a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawStatic()
{
	InvokeHelper(0x4b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawButton()
{
	InvokeHelper(0x4c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDoDrawImage()
{
	InvokeHelper(0x4d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawPort()
{
	InvokeHelper(0x4e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DrawCustomRect(long nType)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x4f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCREPORT::DoDrawLinkNormal()
{
	InvokeHelper(0x50, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawLinkUpRight()
{
	InvokeHelper(0x51, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawCornerLink()
{
	InvokeHelper(0x52, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawBezierLink()
{
	InvokeHelper(0x53, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoRotate()
{
	InvokeHelper(0x54, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoRotateLeft()
{
	InvokeHelper(0x55, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoRotateRight()
{
	InvokeHelper(0x56, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoFlipHorz()
{
	InvokeHelper(0x57, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoFlipVert()
{
	InvokeHelper(0x58, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::RotateAngle(long nAngle)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x59, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nAngle);
}

long CDUCCREPORT::GetRotateShapeCount()
{
	long result;
	InvokeHelper(0x5a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::Group()
{
	InvokeHelper(0x5b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UnGroup()
{
	InvokeHelper(0x5c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::EnableUnGroup()
{
	BOOL result;
	InvokeHelper(0x5d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoAlignLeft()
{
	InvokeHelper(0x5e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignRight()
{
	InvokeHelper(0x5f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignTop()
{
	InvokeHelper(0x60, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignBottom()
{
	InvokeHelper(0x61, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignCenter()
{
	InvokeHelper(0x62, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignVcenter()
{
	InvokeHelper(0x63, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignInviewHor()
{
	InvokeHelper(0x64, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoAlignInviewVer()
{
	InvokeHelper(0x65, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSpaceAcross()
{
	InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSpaceDown()
{
	InvokeHelper(0x67, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSizeWidth()
{
	InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSizeHeight()
{
	InvokeHelper(0x69, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSizeAll()
{
	InvokeHelper(0x6a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoLockcomp()
{
	InvokeHelper(0x6b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoUnlockcomp()
{
	InvokeHelper(0x6c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoMoveForward()
{
	InvokeHelper(0x6d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoMoveBack()
{
	InvokeHelper(0x6e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoMoveBackward()
{
	InvokeHelper(0x6f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoCmdNudgeleft()
{
	InvokeHelper(0x70, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoCmdNudgeright()
{
	InvokeHelper(0x71, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoCmdNudgetop()
{
	InvokeHelper(0x72, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoCmdNudgebottom()
{
	InvokeHelper(0x73, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoCmdAutoPan()
{
	InvokeHelper(0x74, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::GetTotalSelect()
{
	long result;
	InvokeHelper(0x75, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoEditSpot()
{
	InvokeHelper(0x76, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ClearSelectionHandles()
{
	InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::RestoreSelectionHandles()
{
	InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UpdateSelection()
{
	InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UpdateScrollSize()
{
	InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoTabOrder()
{
	InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::SetModifiedFlag(BOOL bFlag)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x7c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bFlag);
}

BOOL CDUCCREPORT::GetModifiedFlag()
{
	BOOL result;
	InvokeHelper(0x7d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::HitTest(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCREPORT::HitTestPort(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCREPORT::GetCompsCount()
{
	long result;
	InvokeHelper(0x80, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetPagePosition(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x81, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCREPORT::ChangePositionWithPages(long nHorzPages, long nVertPages)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x82, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nHorzPages, nVertPages);
}

void CDUCCREPORT::SetLockWithPages(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x83, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

unsigned long CDUCCREPORT::GetGridColor()
{
	unsigned long result;
	InvokeHelper(0x84, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetGridColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x85, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCREPORT::GetGridX()
{
	long result;
	InvokeHelper(0x86, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetGridX(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x87, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCREPORT::GetGridY()
{
	long result;
	InvokeHelper(0x88, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetGridY(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x89, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCREPORT::GetBkColor()
{
	long result;
	InvokeHelper(0x8a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCREPORT::GetPageBkColor()
{
	long result;
	InvokeHelper(0x8c, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetPageBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCREPORT::GetBrushType()
{
	long result;
	InvokeHelper(0x8e, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetBrushType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x8f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

long CDUCCREPORT::GetPatternColor()
{
	long result;
	InvokeHelper(0x90, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetPatternColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x91, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

BOOL CDUCCREPORT::IsFormMode()
{
	BOOL result;
	InvokeHelper(0x92, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetFormMode(BOOL bForm)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x93, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bForm);
}

long CDUCCREPORT::GetCommandState()
{
	long result;
	InvokeHelper(0x94, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::CanUndo()
{
	BOOL result;
	InvokeHelper(0x95, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::CanRedo()
{
	BOOL result;
	InvokeHelper(0x96, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::CanPaste()
{
	BOOL result;
	InvokeHelper(0x97, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetGridStyle()
{
	long result;
	InvokeHelper(0x98, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetGridLineType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x99, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCREPORT::DoPrintPreview(LPDISPATCH frm)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x9a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		frm);
}

void CDUCCREPORT::PrintDraw()
{
	InvokeHelper(0x9b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ChangeModelBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0x9c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCREPORT::ChangeModelStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x9d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCREPORT::ChangeModelIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCREPORT::ChangeModelUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCREPORT::ChangeModelFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xa0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCREPORT::ChangeModelDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xa1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCREPORT::ChangeModelDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xa2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCREPORT::ChangeModelColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xa3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCREPORT::ChangeModelDWordProp(long dwValue, short nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0xa4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeBoolProp(long shape, BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL VTS_I4;
	InvokeHelper(0xa5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeStringProp(long shape, LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR VTS_I4;
	InvokeHelper(0xa6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, strValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeIntProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeUINTProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeFloatProp(long shape, float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R4 VTS_I4;
	InvokeHelper(0xa9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, fValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeDoubleProp(long shape, double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_I4;
	InvokeHelper(0xaa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeDateTimeProp(long shape, DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_DATE VTS_I4;
	InvokeHelper(0xab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dtValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeColorProp(long shape, long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xac, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, crValue, nPropID);
}

void CDUCCREPORT::ChangeSingleShapeDWordProp(long shape, long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0xae, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0xaf, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xb2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xb3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xb4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCREPORT::ChangeSelectionDWordProp(long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCREPORT::AddUserData(long shape, long dwData)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwData);
}

long CDUCCREPORT::GetUserData(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xb8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::MoveShape(long shape, long nxOffset, long nyOffset)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xb9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nxOffset, nyOffset);
}

void CDUCCREPORT::ResizeShape(long shape, double dScaleX, double dScaleY, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8;
	InvokeHelper(0xba, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dScaleX, dScaleY, dOX, dOY);
}

void CDUCCREPORT::RotateShape(long shape, long nAngle, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0xbb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nAngle, dOX, dOY);
}

void CDUCCREPORT::PositionShape(long shape, long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xbc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xLeft, yTop, xRight, yBottom);
}

long CDUCCREPORT::GetCurrentSelectShape()
{
	long result;
	InvokeHelper(0xbd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::FindShapeByCaption(LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszCaption);
	return result;
}

long CDUCCREPORT::FindShapeByName(LPCTSTR lpszName)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszName);
	return result;
}

void CDUCCREPORT::DoPageSetup()
{
	InvokeHelper(0xc0, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsEditSpots()
{
	BOOL result;
	InvokeHelper(0xc1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShowCompsSelectDlg()
{
	InvokeHelper(0xc2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::GetTotalGroupShapes()
{
	long result;
	InvokeHelper(0xc3, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoMoveFront()
{
	InvokeHelper(0xc4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsTabOrder()
{
	BOOL result;
	InvokeHelper(0xc5, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetDrawType()
{
	long result;
	InvokeHelper(0xc6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoDrawCustomShapeID(long nResId)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nResId);
}

void CDUCCREPORT::DoDrawCustomShapeFile(LPCTSTR lpszResFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszResFile);
}

void CDUCCREPORT::UpdateAllShapes()
{
	InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UpdateCanvas()
{
	InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawTable()
{
	InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawArcLine()
{
	InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawPie()
{
	InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowPanWnd()
{
	InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsPanWndShow()
{
	BOOL result;
	InvokeHelper(0xcf, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableDisappearHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsEnablePickNearest()
{
	BOOL result;
	InvokeHelper(0xd1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnablePickNearest(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsAngleSnapEnabled()
{
	BOOL result;
	InvokeHelper(0xd3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableAngleSnap(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCREPORT::SetSnapAngle(long nWink)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nWink);
}

long CDUCCREPORT::GetSnapAngle()
{
	long result;
	InvokeHelper(0xd6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetPrimarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCREPORT::SetSecondarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCREPORT::AddShapePort(double dScaleX, double dScaleY)
{
	static BYTE parms[] =
		VTS_R8 VTS_R8;
	InvokeHelper(0xd9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dScaleX, dScaleY);
}

void CDUCCREPORT::DoDrawMultiSelect()
{
	InvokeHelper(0xda, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::AddArcLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xdb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCREPORT::AddTabShape(long nLeft, long nTop, long nRight, long nBottom, long nRows, long nCols, BOOL bFixRows, BOOL bFixCols, BOOL bShowGridLine)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL;
	InvokeHelper(0xdc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nLeft, nTop, nRight, nBottom, nRows, nCols, bFixRows, bFixCols, bShowGridLine);
	return result;
}

BOOL CDUCCREPORT::IsMultiSelectMode()
{
	BOOL result;
	InvokeHelper(0xdd, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::AddPieShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xde, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCREPORT::AddEllipseChordShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xdf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCREPORT::AddArcLine2Shape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd, bArrow);
	return result;
}

void CDUCCREPORT::SetHlpLineVisible(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xe1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCREPORT::DoDrawArcLine2()
{
	InvokeHelper(0xe2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawEllipseChord()
{
	InvokeHelper(0xe3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoMirrorFree()
{
	InvokeHelper(0xe4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoRemoveHlpLine()
{
	InvokeHelper(0xe5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoShowPosAndSizeDlg()
{
	InvokeHelper(0xe6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ExportAsBitmapFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

void CDUCCREPORT::ExportAsEMFFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

long CDUCCREPORT::AddExtLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCREPORT::AddHorzDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xea, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCREPORT::AddVertDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xeb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCREPORT::AddRadiusDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xec, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCREPORT::AddCaptionShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xed, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight, bArrow);
	return result;
}

long CDUCCREPORT::AddRectCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCREPORT::AddRoundCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xef, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCREPORT::AddCloudCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xf0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

BOOL CDUCCREPORT::IsHlpLineVisible()
{
	BOOL result;
	InvokeHelper(0xf1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsEnableSnapToHelpLine()
{
	BOOL result;
	InvokeHelper(0xf2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableSnapToHelpLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsEnableSnapToControlHandle()
{
	BOOL result;
	InvokeHelper(0xf4, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableSnapToControlHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsEnableSnapToSpot()
{
	BOOL result;
	InvokeHelper(0xf6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableSnapToSpot(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsEnableSnapToIntersectPoint()
{
	BOOL result;
	InvokeHelper(0xf8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableSnapToIntersectPoint(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsCenterDrawAllowed()
{
	BOOL result;
	InvokeHelper(0xfa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableCenterDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xfb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCREPORT::DoDrawCaptionline()
{
	InvokeHelper(0xfc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRectCallout()
{
	InvokeHelper(0xfd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRoundCallout()
{
	InvokeHelper(0xfe, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawCloudCallout()
{
	InvokeHelper(0xff, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawHorzDimline()
{
	InvokeHelper(0x100, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawVertDimline()
{
	InvokeHelper(0x101, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRadiusDimline()
{
	InvokeHelper(0x102, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawExtLine()
{
	InvokeHelper(0x103, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoReverseOrder()
{
	InvokeHelper(0x104, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoInfrontShape()
{
	InvokeHelper(0x105, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoBehindShape()
{
	InvokeHelper(0x106, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsRulerVisible()
{
	BOOL result;
	InvokeHelper(0x107, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::ShowRulers(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x108, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCREPORT::SetRulerUnit(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x109, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCREPORT::DoPutShapeToBack()
{
	InvokeHelper(0x10a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoFoPolyInsertpoint()
{
	InvokeHelper(0x10b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowInsertPoint()
{
	BOOL result;
	InvokeHelper(0x10c, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoFoPolyDeletepoint()
{
	InvokeHelper(0x10d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowDeletePoint()
{
	BOOL result;
	InvokeHelper(0x10e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoConvertSegmentToline()
{
	InvokeHelper(0x10f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowConvertSegmentToLine()
{
	BOOL result;
	InvokeHelper(0x110, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoConvertSegmentToCurve()
{
	InvokeHelper(0x111, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowConvertSegmentToCurve()
{
	BOOL result;
	InvokeHelper(0x112, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoRipUpPoint()
{
	InvokeHelper(0x113, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowRipUpPoint()
{
	BOOL result;
	InvokeHelper(0x114, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoDrawTurnCornerLinkLine()
{
	InvokeHelper(0x115, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawBreakCenterLinkLine()
{
	InvokeHelper(0x116, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoEllipseSelect()
{
	InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoConvertToPath()
{
	InvokeHelper(0x118, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowConvertToPath()
{
	BOOL result;
	InvokeHelper(0x119, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoConvertToPoly()
{
	InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowConvertToPoly()
{
	BOOL result;
	InvokeHelper(0x11b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShapesCombine()
{
	InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShapeCombine()
{
	BOOL result;
	InvokeHelper(0x11d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShapesDismantle()
{
	InvokeHelper(0x11e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShapeDismantle()
{
	BOOL result;
	InvokeHelper(0x11f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShapesMergeMerge()
{
	InvokeHelper(0x120, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShapeMergeMerge()
{
	BOOL result;
	InvokeHelper(0x121, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShapesMergeSubstract()
{
	InvokeHelper(0x122, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShapeMergeSubstract()
{
	BOOL result;
	InvokeHelper(0x123, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShapesMergeIntersect()
{
	InvokeHelper(0x124, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShapeMergeIntersect()
{
	BOOL result;
	InvokeHelper(0x125, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoConnectLines()
{
	InvokeHelper(0x126, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowConnectLines()
{
	BOOL result;
	InvokeHelper(0x127, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoBreakShapeToLines()
{
	InvokeHelper(0x128, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowBreakShapeToLines()
{
	BOOL result;
	InvokeHelper(0x129, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoCloseShape()
{
	InvokeHelper(0x12a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowCloseShape()
{
	BOOL result;
	InvokeHelper(0x12b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShearFree()
{
	InvokeHelper(0x12c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsAllowShearFree()
{
	BOOL result;
	InvokeHelper(0x12d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsEllipseSelectMode()
{
	BOOL result;
	InvokeHelper(0x12e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::ConnectSelectShapes()
{
	InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoGenCreateLink()
{
	InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::AddToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x131, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCREPORT::RemoveShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x132, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCREPORT::GetShapeBoolProp(long shape, long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x133, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID);
	return result;
}

CString CDUCCREPORT::GetShapeStringProp(long shape, long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x134, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCREPORT::GetShapeIntProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x135, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

short CDUCCREPORT::GetShapeUINTProp(long shape, long nPropID)
{
	short result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x136, DISPATCH_METHOD, VT_I2, (void*)&result, parms,
		shape, nPropID);
	return result;
}

float CDUCCREPORT::GetShapeFloatProp(long shape, long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x137, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

double CDUCCREPORT::GetShapeDoubleProp(long shape, long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x138, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		shape, nPropID);
	return result;
}

DATE CDUCCREPORT::GetShapeDateTimeProp(long shape, long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x139, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCREPORT::GetShapeColorProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCREPORT::GetShapeDwordProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCREPORT::ConnectTwoShapes(long shapefirst, long shapesecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapefirst, shapesecond);
	return result;
}

BOOL CDUCCREPORT::IsStaticShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsShapeLinked(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetBoundXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetBoundYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x140, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetBoundWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x141, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetBoundHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x142, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetSnapXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x143, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetSnapYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x144, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetSnapWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x145, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetSnapHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x146, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsPolyObject(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x147, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetInitRotateAngle(long shape, long angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x148, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCREPORT::UpdateComp(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x149, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCREPORT::IsShapeClosed(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14a, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetWithLabelShow(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

void CDUCCREPORT::SetWithLabelEditing(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

BOOL CDUCCREPORT::IsLinkShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsCompositeShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsGroupShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14f, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsKindShape(long shape, long Type)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x150, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, Type);
	return result;
}

long CDUCCREPORT::GetSelectionCount()
{
	long result;
	InvokeHelper(0x151, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetSelection(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x152, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCREPORT::GetShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x153, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCREPORT::GetCompositeShapeChildCount(long shapecomposite)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x154, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapecomposite);
	return result;
}

long CDUCCREPORT::GetCompositeShapeAt(long compositeshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x155, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compositeshape, index);
	return result;
}

long CDUCCREPORT::GetPortsShapePortCount(long portsshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x156, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape);
	return result;
}

long CDUCCREPORT::GetPortsShapePortShapeAt(long portsshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x157, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, index);
	return result;
}

long CDUCCREPORT::GetPortLinkCount(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x158, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCREPORT::GetPortLinkShapeAt(long portshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x159, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape, index);
	return result;
}

long CDUCCREPORT::GetLinkFromShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

long CDUCCREPORT::GetLinkToShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

void CDUCCREPORT::RemoveCurShapeToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCREPORT::IsShapeSelected(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::IsPortShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::AddDefaultPort(long portsshape, double xScale, double yScale)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x15f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, xScale, yScale);
	return result;
}

long CDUCCREPORT::ConnectWithTwoPorts(long portFirst, long portSecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x160, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portFirst, portSecond);
	return result;
}

void CDUCCREPORT::FlashShape(long shape, short times)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x161, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, times);
}

long CDUCCREPORT::GetMaxUndoActionCount()
{
	long result;
	InvokeHelper(0x162, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetMaxRedoActionCount()
{
	long result;
	InvokeHelper(0x163, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetMaxUndoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCREPORT::SetMaxRedoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x165, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCREPORT::ChangeRulerUnit(short unit)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x166, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		unit);
}

void CDUCCREPORT::SelectShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x167, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCREPORT::GetBackgroundShapeCount()
{
	long result;
	InvokeHelper(0x168, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetBackShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x169, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCREPORT::AddShapeToBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCREPORT::RemoveShapeFromBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCREPORT::RemoveAllShapesFromBack()
{
	InvokeHelper(0x16c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::FindShapeWithNameFromBack(LPCTSTR Name)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x16d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		Name);
	return result;
}

long CDUCCREPORT::CloneShape(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::RemoveAllPorts(long portsshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		portsshape);
}

long CDUCCREPORT::GetShapePointCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x170, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetShapePointXAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x171, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

long CDUCCREPORT::GetShapePointYAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x172, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

void CDUCCREPORT::AddShapePoint(long shape, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x173, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, x, y);
}

void CDUCCREPORT::RemoveShapePoint(long shape, long index)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x174, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index);
}

void CDUCCREPORT::InsertShapePoint(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x175, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

void CDUCCREPORT::SetShapePointAt(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x176, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

BOOL CDUCCREPORT::IsToolBoxVisible()
{
	BOOL result;
	InvokeHelper(0x177, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::ShowToolBoxWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x178, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::RomoveToolBoxPage(long index)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x179, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		index);
}

long CDUCCREPORT::GetToolBoxPageCount()
{
	long result;
	InvokeHelper(0x17a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableToolboxEditProp(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x17b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCREPORT::FODPtoLPX(long xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCREPORT::FODPtoLPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

long CDUCCREPORT::FOLPtoDPX(short xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x17e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCREPORT::FOLPtoDPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

void CDUCCREPORT::EnableUniqueCaption(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x180, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCREPORT::EnableUniqueName(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x181, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCREPORT::GetPortParentShape(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x182, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCREPORT::CreateShape(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x183, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

void CDUCCREPORT::AddListField(long listshape, short index, BOOL bshowleftport, BOOL bshowrightport, LPCTSTR strfield)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL VTS_BOOL VTS_BSTR;
	InvokeHelper(0x184, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		listshape, index, bshowleftport, bshowrightport, strfield);
}

void CDUCCREPORT::UpdateShapeGeo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x185, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCREPORT::FindPortFromIndex(long listshape, short index, BOOL bLeftPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL;
	InvokeHelper(0x186, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape, index, bLeftPort);
	return result;
}

long CDUCCREPORT::LinkTwoField(long FromPort, long ToPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x187, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromPort, ToPort);
	return result;
}

long CDUCCREPORT::GetFieldCountOfListCtrl(long listshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x188, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape);
	return result;
}

CString CDUCCREPORT::GetFieldCaption(long listshape, short index)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x189, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		listshape, index);
	return result;
}

void CDUCCREPORT::DoDrawImageNode(LPDISPATCH iPictureDisp)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x18a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		iPictureDisp);
}

long CDUCCREPORT::AddImageNode(short x, short y, LPDISPATCH iPictureDisp)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_DISPATCH;
	InvokeHelper(0x18b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		x, y, iPictureDisp);
	return result;
}

void CDUCCREPORT::EnableContinueDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x18c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCREPORT::DoMakeSubgraph()
{
	InvokeHelper(0x18d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UnGroupSubgraph()
{
	InvokeHelper(0x18e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoVCPrintPreview()
{
	InvokeHelper(0x18f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ChangeToolBoxBackColor(long crFirst, long crLast)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x190, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crFirst, crLast);
}

BOOL CDUCCREPORT::GetModelBoolProp(long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x191, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		nPropID);
	return result;
}

CString CDUCCREPORT::GetModelStringProp(long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x192, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCREPORT::GetModelIntProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x193, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

float CDUCCREPORT::GetModelFloatProp(long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x194, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		nPropID);
	return result;
}

double CDUCCREPORT::GetModelDoubleProp(long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x195, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		nPropID);
	return result;
}

DATE CDUCCREPORT::GetModelDateTimeProp(long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x196, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCREPORT::GetModelColorProp(float nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_R4;
	InvokeHelper(0x197, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCREPORT::GetModelDWordProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x198, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

void CDUCCREPORT::DoDrawEllipse2()
{
	InvokeHelper(0x199, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::AddEllipse2Shape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x19a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

void CDUCCREPORT::DoDrawNewBizerLine()
{
	InvokeHelper(0x19b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::EnterEditingBack()
{
	InvokeHelper(0x19c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::EndEditingBack()
{
	InvokeHelper(0x19d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCREPORT::IsModified()
{
	BOOL result;
	InvokeHelper(0x19e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoAutoReroute()
{
	InvokeHelper(0x19f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::AddSimplePathShape(long xStart, long yStart, long xEnd, long yEnd, short nType)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1a0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nType);
	return result;
}

void CDUCCREPORT::EnableFreeFormDrawing(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsFreeFormDrawing()
{
	BOOL result;
	InvokeHelper(0x1a2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsEnableSnapDynGrid()
{
	BOOL result;
	InvokeHelper(0x1a3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::EnableSnapDynGrid(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCREPORT::EnableSnapAidLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsEnableSnapAidLine()
{
	BOOL result;
	InvokeHelper(0x1a6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::ShowColorThemeDlg()
{
	InvokeHelper(0x1a7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawCurveLink()
{
	InvokeHelper(0x1a8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoDrawRoundCornerLinkLine()
{
	InvokeHelper(0x1a9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::MoveShapeTo(long shape, long xPos, long yPos)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1aa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xPos, yPos);
}

void CDUCCREPORT::SetShapeDimension(long shape, long Width, long Height)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, Width, Height);
}

BOOL CDUCCREPORT::GetShapeShowLabelAtFirst(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ac, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetShapeShowLabelAtFirst(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1ad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCREPORT::GetShapeWithLabelShow(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ae, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetShapeWithLabelShow(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1af, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCREPORT::GetShapeWithLabelEditing(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1b0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetShapeWithLabelEditing(long shape, BOOL bEnable)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1b1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bEnable);
}

void CDUCCREPORT::MPreparePtAry()
{
	InvokeHelper(0x1b2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::MAddPtToAry(long xPoint, long yPoint)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1b3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xPoint, yPoint);
}

long CDUCCREPORT::AddPolylineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCREPORT::MAddPolygonShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCREPORT::MAddBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCREPORT::MAddCloseBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCREPORT::MAddExtBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

void CDUCCREPORT::MAddLinkShape(short nLinkType, long FromPort, long ToPort, short arrowtype)
{
	static BYTE parms[] =
		VTS_I2 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1b9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, FromPort, ToPort, arrowtype);
}

long CDUCCREPORT::GetShapeCenterPort(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ba, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetApplicationName(LPCTSTR pszAppName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1bb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		pszAppName);
}

BOOL CDUCCREPORT::FindShapeWithinDataModel(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1bc, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCREPORT::AddBoolUserProperty(long shape, long nPropID, BOOL bValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1bd, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, bValue);
	return result;
}

BOOL CDUCCREPORT::AddStringUserProperty(long shape, long nPropID, LPCTSTR strValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1be, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, strValue);
	return result;
}

BOOL CDUCCREPORT::AddIntUserProperty(long shape, long nPropID, long nValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1bf, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, nValue);
	return result;
}

BOOL CDUCCREPORT::AddFloatUserProperty(long shape, long nPropID, float fValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, fValue);
	return result;
}

BOOL CDUCCREPORT::AddDoubleUserProperty(long shape, long nPropID, double dValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c1, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dValue);
	return result;
}

BOOL CDUCCREPORT::AddDateUserProperty(long shape, long nPropID, DATE dtTime)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1c2, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dtTime);
	return result;
}

BOOL CDUCCREPORT::AddColorUserProperty(long shape, long nPropID, long crColor)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c3, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, crColor);
	return result;
}

BOOL CDUCCREPORT::AddDWordUserProperty(long shape, long nPropID, long dwData)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dwData);
	return result;
}

void CDUCCREPORT::ChangeShapeBoolWithoutUndo(long shape, long nPropID, BOOL bValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1c5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, bValue);
}

void CDUCCREPORT::ChangeShapeStringWithoutUndo(long shape, long nPropID, LPCTSTR strValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1c6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, strValue);
}

void CDUCCREPORT::ChangeShapeIntWithoutUndo(long shape, long nPropID, long nValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, nValue);
}

void CDUCCREPORT::ChangeShapeFloatWithoutUndo(long shape, long nPropID, float fValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, fValue);
}

void CDUCCREPORT::ChangeShapeDoubleWithoutUndo(long shape, long nPropID, double dValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dValue);
}

void CDUCCREPORT::ChangeShapeDWordWithoutUndo(long shape, long nPropID, long dwValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ca, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dwValue);
}

void CDUCCREPORT::ChangeShapeColorWithoutUndo(long shape, long nPropID, long crColor)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1cb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, crColor);
}

void CDUCCREPORT::ChangeShapeDateWithoutUndo(long shape, long nPropID, DATE dtValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1cc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dtValue);
}

long CDUCCREPORT::GetLinkCount()
{
	long result;
	InvokeHelper(0x1cd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetLinkAt(long nIndex)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ce, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nIndex);
	return result;
}

long CDUCCREPORT::GetSelectedLinkCount()
{
	long result;
	InvokeHelper(0x1cf, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetSelectedLinkAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCREPORT::RemoveShapeWithoutUndo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCREPORT::GetShapeLinksCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetShapeLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetShapeFromLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetShapeFromLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetShapeToLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetShapeToLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetDirectLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetDirectLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetDirectLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1da, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetDirectLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1db, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetDirectLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1dc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetDirectLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1dd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetAllLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1de, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetAllLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1df, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetAllLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetAllLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetAllLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCREPORT::GetAllLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCREPORT::GetFocusShape()
{
	long result;
	InvokeHelper(0x1e4, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::AddLinkShapeNoUndo(long FromNode, long ToNode, short LinkType, short arrowtype)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromNode, ToNode, LinkType, arrowtype);
	return result;
}

void CDUCCREPORT::ChangeToolBoxIndexFile(LPCTSTR strNewFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1e6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strNewFile);
}

void CDUCCREPORT::DoShowProtDlg()
{
	InvokeHelper(0x1e7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::SaveToImage()
{
	long result;
	InvokeHelper(0x1e8, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::LoadFromImage(long hEmf, short xStart, short yStart)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		hEmf, xStart, yStart);
	return result;
}

void CDUCCREPORT::EndTextBoxEdit()
{
	InvokeHelper(0x1ea, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::EndEditBoxEdit()
{
	InvokeHelper(0x1eb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::EndComboBoxEdit()
{
	InvokeHelper(0x1ec, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::StartRichTextEdit(long richshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ed, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		richshape);
}

long CDUCCREPORT::SaveMemory(long* xlen)
{
	long result;
	static BYTE parms[] =
		VTS_PI4;
	InvokeHelper(0x1ee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xlen);
	return result;
}

void CDUCCREPORT::LoadMemory(long hMem, long* xlen)
{
	static BYTE parms[] =
		VTS_I4 VTS_PI4;
	InvokeHelper(0x1ef, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		hMem, xlen);
}

BOOL CDUCCREPORT::SaveMemory2(LPCTSTR filename, long pData, long nSize)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4 VTS_I4;
	InvokeHelper(0x1f0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		filename, pData, nSize);
	return result;
}

long CDUCCREPORT::LoadMemory2(LPCTSTR filename, long lpData)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x1f1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		filename, lpData);
	return result;
}

void CDUCCREPORT::InsertOleShape()
{
	InvokeHelper(0x1f2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ShowOpenFileDialog()
{
	InvokeHelper(0x1f3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ShowSaveFileDialog()
{
	InvokeHelper(0x1f4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ShowTemplateOpenDialog()
{
	InvokeHelper(0x1f5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ShowSaveTemplateDialog()
{
	InvokeHelper(0x1f6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::ShowOptionDialog()
{
	InvokeHelper(0x1f7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::UpdateAllWindows()
{
	InvokeHelper(0x1f8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::DoSetDBName()
{
	InvokeHelper(0x1f9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCREPORT::AddBoxShape(long xPos, long yPos, long szWidth, long szHeight, LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPos, yPos, szWidth, szHeight, strCaption);
	return result;
}

long CDUCCREPORT::GetShapeType(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

CString CDUCCREPORT::GetCurrentText(long shape)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fc, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetCurrentText(long shape, LPCTSTR sText)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fd, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, sText);
}

BOOL CDUCCREPORT::IsEFormShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fe, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetEFormFocusShape()
{
	long result;
	InvokeHelper(0x1ff, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SetPointLimitWithPage(BOOL bWithIn)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x200, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bWithIn);
}

void CDUCCREPORT::ShowBarCodeLabel(long barcodeshape, BOOL bVisible)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x201, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		barcodeshape, bVisible);
}

void CDUCCREPORT::UpdateControl(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x202, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCREPORT::GetRunTimeInputText()
{
	InvokeHelper(0x203, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::SetFocusOnShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x204, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCREPORT::LoadXdgFromFile(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x205, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCREPORT::SaveToXdgFile(LPCTSTR lpszFileName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x206, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszFileName);
}

long CDUCCREPORT::FindShapeWithKey1(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x207, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCREPORT::FindShapeWithKey2(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x208, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCREPORT::FindShapeWithKey3(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x209, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCREPORT::FindShapeWithKeyInComp1(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCREPORT::FindShapeWithKeyInComp2(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCREPORT::FindShapeWithKeyInComp3(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

void CDUCCREPORT::RotateFromCenter(long shape, short angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x20d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCREPORT::MoveCenterTo(long shape, long xNew, long yNew)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x20e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xNew, yNew);
}

void CDUCCREPORT::ScaleFromCenter(long shape, double dX, double dY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x20f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dX, dY);
}

void CDUCCREPORT::InitLinkTypeAndArrow(short nLinkType, short nArrowType)
{
	static BYTE parms[] =
		VTS_I2 VTS_I2;
	InvokeHelper(0x210, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, nArrowType);
}

long CDUCCREPORT::AddShapeWithoutUndo(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x211, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCREPORT::GetCanvasWidth2()
{
	long result;
	InvokeHelper(0x212, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetCanvasHeight2()
{
	long result;
	InvokeHelper(0x213, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::ShowPortPinName(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x214, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::RemoveAllFromSelection(BOOL bRedraw)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x215, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bRedraw);
}

BOOL CDUCCREPORT::DoBendFree()
{
	BOOL result;
	InvokeHelper(0x216, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsAllowBendFree()
{
	BOOL result;
	InvokeHelper(0x217, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::SelectNewShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x218, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCREPORT::ShowPanWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x219, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowFileBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowDrawBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowFontBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowFormartBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowAlignBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowStatusBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowLinkBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x220, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::ShowOperatorBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x221, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCREPORT::SetAllowHoleLink(short bEnable)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x222, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCREPORT::IsPanWindowVisible()
{
	BOOL result;
	InvokeHelper(0x223, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsFileBarVisible()
{
	BOOL result;
	InvokeHelper(0x224, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsDrawBarVisible()
{
	BOOL result;
	InvokeHelper(0x225, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsFontBarVisible()
{
	BOOL result;
	InvokeHelper(0x226, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsFormatBarVisible()
{
	BOOL result;
	InvokeHelper(0x227, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsAlignBarVisible()
{
	BOOL result;
	InvokeHelper(0x228, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsLinkBarVisible()
{
	BOOL result;
	InvokeHelper(0x229, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsOptBarVisible()
{
	BOOL result;
	InvokeHelper(0x22a, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCREPORT::IsStatusBarVisible()
{
	BOOL result;
	InvokeHelper(0x22b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCREPORT::DoShowKeyDlg()
{
	InvokeHelper(0x22c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

double CDUCCREPORT::ConvertToMapLog(double dConvertValue, short dUnit, BOOL bVert)
{
	double result;
	static BYTE parms[] =
		VTS_R8 VTS_I2 VTS_BOOL;
	InvokeHelper(0x22d, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		dConvertValue, dUnit, bVert);
	return result;
}

void CDUCCREPORT::OnNewFile()
{
	InvokeHelper(0x22e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::SetCanvasSize(long szWidthPt, long szHeightPt)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x22f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		szWidthPt, szHeightPt);
}

double CDUCCREPORT::GetGaugeCurrentValue(long gaugeshape)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x230, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		gaugeshape);
	return result;
}

void CDUCCREPORT::SetGaugeCurrentValue(long gaugeshape, double newvalue)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8;
	InvokeHelper(0x231, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		gaugeshape, newvalue);
}

BOOL CDUCCREPORT::SaveTemplateToFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x232, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

BOOL CDUCCREPORT::LoadTemplateFromFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x233, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

double CDUCCREPORT::GetZoomXScale()
{
	double result;
	InvokeHelper(0x234, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCREPORT::GetZoomYScale()
{
	double result;
	InvokeHelper(0x235, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCREPORT::GetUIScale()
{
	double result;
	InvokeHelper(0x236, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetUIUnit()
{
	long result;
	InvokeHelper(0x237, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCREPORT::GetShapeID(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x238, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCREPORT::SetShapeID(long shape, long nId)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x239, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nId);
}

long CDUCCREPORT::FindShapeByID(long nId)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nId);
	return result;
}

long CDUCCREPORT::NewConnectTwoShapes(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x23b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey);
	return result;
}

long CDUCCREPORT::ConnectShapeWithPorts(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey, short nLinkStyle)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I2;
	InvokeHelper(0x23c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey, nLinkStyle);
	return result;
}

CXDShape CDUCCREPORT::Convert(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23d, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDShape(pDispatch);
}

void CDUCCREPORT::LockUpdate(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

BOOL CDUCCREPORT::IsLockUpdate()
{
	BOOL result;
	InvokeHelper(0x23f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

CXDGroupShape CDUCCREPORT::ConvertToGroup(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x240, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDGroupShape(pDispatch);
}

CXDLinkShape CDUCCREPORT::ConvertToLink(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x241, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDLinkShape(pDispatch);
}

CXDPortsShape CDUCCREPORT::ConvertToPortsShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x242, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortsShape(pDispatch);
}

CXDPortShape CDUCCREPORT::ConvertToPortShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x243, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortShape(pDispatch);
}

CXDEFormShape CDUCCREPORT::ConvertToEFormShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x244, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDEFormShape(pDispatch);
}

void CDUCCREPORT::UpdateFullWindows()
{
	InvokeHelper(0x245, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::HideAllToolBars()
{
	InvokeHelper(0x246, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::HideCanvasBorder()
{
	InvokeHelper(0x247, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCREPORT::HideAllScrollBars()
{
	InvokeHelper(0x248, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}
